//###############################################################
//# mask1_slots.h for ProcessViewServer created: Thu Mar 13 15:52:15 2008
//# please fill out these slots
//# here you find all possible events
//# Yours: Lehrig Software Engineering
//###############################################################

// todo: uncomment me if you want to use this data aquisiton
// also uncomment this classes in main.cpp and pvapp.h
// also remember to uncomment rllib in the project file
//extern rlModbusClient     modbus;
//extern rlSiemensTCPClient siemensTCP;
//extern rlPPIClient        ppi;

using namespace std;

typedef struct // (todo: define your data structure here)
{
  rlSvgAnimator svgAnimator;
  map<string, mySvgObject> mySvgObjects;
  float fSpeed;
}
DATA;

static int drawSVG(PARAM *p, int id, DATA *d);

static int slotInit(PARAM *p, DATA *d)
{
  if(p == NULL || d == NULL) return -1;
  //memset(d,0,sizeof(DATA));

  // load SVG
  d->svgAnimator.setSocket(&p->s);
  d->svgAnimator.setId(svgPrimary);
  d->svgAnimator.read("img/myExample.svg");

  d->fSpeed = 5.0;

  // svg-field stack to window
  pvSetZoomX(p, svgPrimary, -1.0f);
  pvSetZoomY(p, svgPrimary, -1.0f);

  // draw svg
  drawSVG(p,svgPrimary,d);

  //request the coordinates and sizes of the following SVG elements 
  pvRequestSvgBoundsOnElement(p, svgPrimary, "roll01");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "roll02");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "roll03");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "roll04");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "box01");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "box02");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "box03");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "box04");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "box05");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "box06");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "box07");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "@slidebar01");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "@slider01");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "@slidebar02");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "@slider02");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "wall01");
  pvRequestSvgBoundsOnElement(p, svgPrimary, "wall02");

  return 0;
}

static int slotNullEvent(PARAM *p, DATA *d)
{
  int i;
  char oName[8];

  if(p == NULL || d == NULL) return -1;

  //don't start until we have the last of the requested bounds
  if(d->mySvgObjects["wall02"].init.x0!=-1)  
  {
    //we divide the speed of the boxes by the perimeter of the rolls and translate it into RADs. This is to make the rolls rotate accordingly to the speed of the boxes
    for(i=1;i<5;i++)
    {
      sprintf(oName, "roll0%d", i);
      d->mySvgObjects[oName].setAlpha( d->mySvgObjects[oName].getAlpha() + (d->fSpeed / (PI * d->mySvgObjects[oName].init.h / 360.0)) * (2.0 * PI / 360.0));
      d->mySvgObjects[oName].rotate(d->mySvgObjects[oName].getAlpha(), d->mySvgObjects[oName].init.x0 + d->mySvgObjects[oName].init.w/2.0 , d->mySvgObjects[oName].init.y0 + d->mySvgObjects[oName].init.h/2.0);
      d->svgAnimator.setMatrix(oName, d->mySvgObjects[oName]);
    }

    //loop for all of the boxes
    for(i=1;i<8;i++)
    {
      sprintf(oName, "box0%d", i);

      d->mySvgObjects[oName].setSpeed(d->fSpeed);

      //recalculate the coordinates of the zoomed object to align it with the unzoomed c.s.
      if(d->mySvgObjects[oName].getZoom() != d->mySvgObjects[oName].sx)
      {
	d->mySvgObjects[oName].moveRelative(d->mySvgObjects[oName].init.x0 * (d->mySvgObjects[oName].sx - d->mySvgObjects[oName].getZoom()), (d->mySvgObjects[oName].init.y0 + d->mySvgObjects[oName].init.h) * (d->mySvgObjects[oName].sx - d->mySvgObjects[oName].getZoom()));
      }

      //perform the actual zoom
      d->mySvgObjects[oName].scale(d->mySvgObjects[oName].getZoom());

      //if the box has reached the end of the line (wall02) it is to be moved to the begining of the line (wall01).
      if(d->mySvgObjects[oName].init.x0 * d->mySvgObjects[oName].getZoom() + d->mySvgObjects[oName].x0 >= d->mySvgObjects["wall02"].init.x0)
      {
	d->mySvgObjects[oName].move(d->mySvgObjects["wall01"].init.x0 - d->mySvgObjects[oName].init.x0 * d->mySvgObjects[oName].sx, d->mySvgObjects[oName].y0);
	d->svgAnimator.svgTextPrintf("text03", "Status: %s passed", oName);
      }
      else
      {
	d->mySvgObjects[oName].moveRelative(d->mySvgObjects[oName].getSpeed(), 0.0);
      }

      d->svgAnimator.setMatrix(oName, d->mySvgObjects[oName]);
    }

    drawSVG(p, svgPrimary, d);
  }
  return 0;
}

static int slotButtonEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotButtonPressedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotButtonReleasedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTextEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  float x,y,w,h;
  switch(textEventType(text))
  {
    case PLAIN_TEXT_EVENT:
      printf("plain\n");
      break;
    case SVG_LEFT_BUTTON_PRESSED:
      printf("left pressed -> %s\n", svgObjectName(text));
      //used to determine the dragging of the sliders
      d->mySvgObjects[svgObjectName(text)].setClicked(true);
      break;
    case SVG_MIDDLE_BUTTON_PRESSED:
      printf("middle pressed\n");
      break;
    case SVG_RIGHT_BUTTON_PRESSED:
      printf("right pressed\n");
      break;
    case SVG_LEFT_BUTTON_RELEASED:
      printf("left released -> %s\n", svgObjectName(text));
      //used to determine the dragging of the sliders
      d->mySvgObjects["@slider01"].setClicked(false);
      d->mySvgObjects["@slider02"].setClicked(false);
      break;
    case SVG_MIDDLE_BUTTON_RELEASED:
      printf("middle released\n");
      break;
    case SVG_RIGHT_BUTTON_RELEASED:
      printf("right released\n");
      break;
    case SVG_BOUNDS_ON_ELEMENT:
      getSvgBoundsOnElement(text, &x, &y, &w, &h);
      printf("bounds object=%s xywh=%f,%f,%f,%f\n",svgObjectName(text),x,y,w,h);
      d->mySvgObjects[string(svgObjectName(text))].setInit(x, y, w, h);

      break;
    default:
      printf("default\n");
      break;
  }
  return 0;
}

static int slotSliderEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotCheckboxEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotRadioButtonEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotGlInitializeEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlPaintEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlResizeEvent(PARAM *p, int id, DATA *d, int width, int height)
{
  if(p == NULL || id == 0 || d == NULL || width < 0 || height < 0) return -1;
  return 0;
}

static int slotGlIdleEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTabEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotTableTextEvent(PARAM *p, int id, DATA *d, int x, int y, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || text == NULL) return -1;
  return 0;
}

static int slotTableClickedEvent(PARAM *p, int id, DATA *d, int x, int y, int button)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || button < 0) return -1;
  return 0;
}

static int slotSelectionEvent(PARAM *p, int id, DATA *d, int val, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || text == NULL) return -1;
  return 0;
}

static int slotClipboardEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotRightMouseEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotKeyboardEvent(PARAM *p, int id, DATA *d, int val, int modifier)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || modifier < -1000) return -1;
  return 0;
}

static int slotMouseMovedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  int i;
  char oName[8];

  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;

  //if the user is dragging slider01 we move the slider01 accordingly and change the speed
  if(d->mySvgObjects["@slider01"].isClicked())
  {
    if(x < d->mySvgObjects["@slidebar01"].init.x0 ) 
    {
      x=d->mySvgObjects["@slidebar01"].init.x0;
    }
    if(x > d->mySvgObjects["@slidebar01"].init.x0 + d->mySvgObjects["@slidebar01"].init.w)
    {
      x=d->mySvgObjects["@slidebar01"].init.x0 + d->mySvgObjects["@slidebar01"].init.w;
    }

    d->mySvgObjects["@slider01"].move(x - d->mySvgObjects["@slider01"].init.x0, 0.0);
    d->fSpeed = (x - d->mySvgObjects["@slidebar01"].init.x0 ) * 10.0 / d->mySvgObjects["@slidebar01"].init.w;

    d->svgAnimator.svgTextPrintf("text01", "Speed: %.2f", d->fSpeed);

    d->svgAnimator.setMatrix("@slider01", d->mySvgObjects["@slider01"]);
    drawSVG(p, svgPrimary, d);
  }

  //if the user is dragging slider02 we move the slider02 accordingly and change the zoom
  if(d->mySvgObjects["@slider02"].isClicked())
  {
    if(y < d->mySvgObjects["@slidebar02"].init.y0 ) 
    {
      y=d->mySvgObjects["@slidebar02"].init.y0;
    }
    if(y > d->mySvgObjects["@slidebar02"].init.y0 + d->mySvgObjects["@slidebar02"].init.h)
    {
      y=d->mySvgObjects["@slidebar02"].init.y0 + d->mySvgObjects["@slidebar02"].init.h;
    }

    d->mySvgObjects["@slider02"].move(0.0, y - d->mySvgObjects["@slider02"].init.y0);
    d->svgAnimator.setMatrix("@slider02", d->mySvgObjects["@slider02"]);

    for(i=1;i<8;i++)
    {
      sprintf(oName, "box0%d", i);
      d->mySvgObjects[oName].setZoom((d->mySvgObjects["@slidebar02"].init.h - (y - d->mySvgObjects["@slidebar02"].init.y0)) * 2.0 / d->mySvgObjects["@slidebar02"].init.h);
    }

    d->svgAnimator.svgTextPrintf("text02", "Zoom: x%.2f", d->mySvgObjects[oName].getZoom());

    drawSVG(p, svgPrimary, d);

  }

  return 0;
}

static int slotMousePressedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  int i;
  char oName[8];

  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;

  //if the user has clicked slidebar01 we move the slider01 accordingly and change the speed
  if(d->mySvgObjects["@slidebar01"].isClicked())
  {
    d->mySvgObjects["@slidebar01"].setClicked(false);
    if(x < d->mySvgObjects["@slidebar01"].init.x0 ) 
    {
      x=d->mySvgObjects["@slidebar01"].init.x0;
    }
    if(x > d->mySvgObjects["@slidebar01"].init.x0 + d->mySvgObjects["@slidebar01"].init.w)
    {
      x=d->mySvgObjects["@slidebar01"].init.x0 + d->mySvgObjects["@slidebar01"].init.w;
    }

    d->mySvgObjects["@slider01"].move(x - d->mySvgObjects["@slider01"].init.x0, 0.0);
    d->fSpeed = (x - d->mySvgObjects["@slidebar01"].init.x0 ) * 10.0 / d->mySvgObjects["@slidebar01"].init.w;

    d->svgAnimator.svgTextPrintf("text01", "Speed: %.2f", d->fSpeed);

    d->svgAnimator.setMatrix("@slider01", d->mySvgObjects["@slider01"]);
    drawSVG(p, svgPrimary, d);
  }

  //if the user has clicked slidebar02 we move the slider02 accordingly and change the zoom
  if(d->mySvgObjects["@slidebar02"].isClicked())
  {
    d->mySvgObjects["@slidebar02"].setClicked(false);
    if(y < d->mySvgObjects["@slidebar02"].init.y0 ) 
    {
      y=d->mySvgObjects["@slidebar02"].init.y0;
    }
    if(y > d->mySvgObjects["@slidebar02"].init.y0 + d->mySvgObjects["@slidebar02"].init.h)
    {
      y=d->mySvgObjects["@slidebar02"].init.y0 + d->mySvgObjects["@slidebar02"].init.h;
    }

    d->mySvgObjects["@slider02"].move(0.0, y - d->mySvgObjects["@slider02"].init.y0);
    d->svgAnimator.setMatrix("@slider02", d->mySvgObjects["@slider02"]);
    
    //as there is no global variable for the zoom we go through all the objects we'd like to zoom and we change their zoom ratio
    for(i=1;i<8;i++)
    {
      sprintf(oName, "box0%d", i);
      d->mySvgObjects[oName].setZoom((d->mySvgObjects["@slidebar02"].init.h - (y - d->mySvgObjects["@slidebar02"].init.y0)) * 2.0 / d->mySvgObjects["@slidebar02"].init.h);
    }

    d->svgAnimator.svgTextPrintf("text02", "Zoom: x%.2f", d->mySvgObjects[oName].getZoom());

    drawSVG(p, svgPrimary, d);
  }

  return 0;
}

static int slotMouseReleasedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  //stop sliding
  d->mySvgObjects["@slider01"].setClicked(false);
  d->mySvgObjects["@slider02"].setClicked(false);

  return 0;
}

static int slotMouseOverEvent(PARAM *p, int id, DATA *d, int enter)
{
  if(p == NULL || id == 0 || d == NULL || enter < -1000) return -1;
  return 0;
}

static int slotUserEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

//custom functions
static int drawSVG(PARAM *p, int id, DATA *d)
{
  if(d == NULL) return -1;
  gBeginDraw(p,id);
  d->svgAnimator.writeSocket();
  gEndDraw(p);
  return 0;
}
